/*
 * Copyright (C) 2012  Christian Mollekopf <mollekopf@kolabsys.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef FBGENERATORJOB_H
#define FBGENERATORJOB_H
#include <kjob.h>
#include <kimap/session.h>
#include <kimap/fetchjob.h>
#include "kolabjob.h"

class FBGeneratorJob: public KolabJob
{
    Q_OBJECT
public:
    explicit FBGeneratorJob(const QString &hostName, qint16 port, const QString &username, QObject* parent = 0);
private Q_SLOTS:
    void onFetchFBDone(KJob *job);
    void onGenerateFBDone(KJob*);
    void onModDone(KJob*);
protected:
    virtual QStringList requiredFolders();
private:
    virtual void startWork(ProbeKolabServerJob* job);

    QString mFreebusyFolder;
    QStringList mEventFolders;

    qint64 mOldImapUid;
    KIMAP::MessageFlags mOldFlags;
};

#endif // FBGENERATORJOB_H
