/*
 * Copyright (C) 2012  Christian Mollekopf <mollekopf@kolabsys.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef GENERATEFBJOB_H
#define GENERATEFBJOB_H
#include <kjob.h>
#include <QTime>
#include <kolabfreebusy.h>
#include <kimap/session.h>
#include <kimap/fetchjob.h>
#include <kmime/kmime_message.h>
#include <kcalcore/person.h>

/**
 * Get events and generate a fb object
 */
class GenerateFBJob: public KJob
{
    Q_OBJECT
public:
    explicit GenerateFBJob(const QStringList &kolabEventFolders, const KDateTime &start, const KDateTime &end, KIMAP::Session *, QObject* parent = 0);
    virtual void start();
    Kolab::Freebusy getFreebusy() const;
private Q_SLOTS:
    void onFetchDone(KJob *job);
private:
    void checkJobDone();
    QStringList mKolabEventFolders;
    Kolab::Freebusy mFreebusy;
    KIMAP::Session *mSession;
    KDateTime mStart;
    KDateTime mEnd;
    QTime mTime;
};

#endif // GENERATEFBJOB_H
