/*
 * Copyright (C) 2012  Christian Mollekopf <mollekopf@kolabsys.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef KOLABJOB_H
#define KOLABJOB_H
#include <kimap/session.h>
#include <QStringList>

#define X_ORIGIN_HEADER "X-Freebusy-Origin"

class ProbeKolabServerJob;
class KolabJob: public KJob
{
    Q_OBJECT
public:
    explicit KolabJob(const QString &hostName, qint16 port, const QString &username, QObject* parent = 0);
    virtual void start();
    
private Q_SLOTS:
    void onSessionStateChanged(KIMAP::Session::State newState, KIMAP::Session::State oldState);
    void onAuthDone(KJob*);
    void onProbeDone(KJob* job);
    void onLogoutDone(KJob*);

protected:
    virtual QStringList requiredFolders();
    virtual void startWork(ProbeKolabServerJob *job) = 0;
    void logout();
    QString mHostName;
    qint16 mPort;
    QString mUserName;

    QString mFreebusyFolder;

    KIMAP::Session *mSession;

};

#endif // KOLABJOB_H
