/*
    <one line to give the library's name and an idea of what it does.>
    Copyright (C) 2012  Christian Mollekopf <chrigi_1@fastmail.fm>

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Affero General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/


#ifndef MESSAGEMODIFYJOB_H
#define MESSAGEMODIFYJOB_H

#include <kcompositejob.h>
#include <kimap/session.h>
#include <kmime/kmime_message.h>

class MessageModifyJob : public KCompositeJob
{
    Q_OBJECT
public:
    explicit MessageModifyJob(const KMime::Message::Ptr& content, const QString &mailbox, const QList<QByteArray> flags, qint64 uid, KIMAP::Session* session, QObject* parent);
    virtual void start();
private slots:
    void onAppendMessageDone( KJob *job );
    void onPreDeleteSelectDone( KJob *job );
    void onDeleteDone( KJob *job );
private:
    void triggerDeleteJob();
    KIMAP::Session *m_session;
    KMime::Message::Ptr m_newContent;
    QString m_mailbox;
    QList<QByteArray> m_flags;
    qint64 m_oldUid;
};

#endif // MESSAGEMODIFYJOB_H
