/*
 * Copyright (C) 2012  Christian Mollekopf <mollekopf@kolabsys.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef OBJECT_H
#define OBJECT_H

#include <kmime/kmime_message.h>
#include <kcalcore/incidence.h>

Q_DECLARE_METATYPE( KCalCore::Incidence::Ptr )
Q_DECLARE_METATYPE( KMime::Message::Ptr )

//Little helper class to distinguish notes from plain Mime messages
struct Note
{
    KMime::Message::Ptr msg;
};
Q_DECLARE_METATYPE( Note )

struct Dictionary
{
    QString lang;
    QStringList dict;
};
Q_DECLARE_METATYPE( Dictionary )

struct Object
{
    QVariant object;
    QList<QByteArray> flags;
};

#endif // OBJECT_H
