/*
 * Copyright (C) 2012  Christian Mollekopf <mollekopf@kolabsys.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef COORDINATIONJOB_H
#define COORDINATIONJOB_H
#include <kjob.h>

class KolabServer;
class SourceServer;
class CoordinationJob: public KJob
{
    Q_OBJECT
public:
    explicit CoordinationJob(SourceServer *sourceServer, KolabServer *kolabServer, QObject* parent = 0);
    virtual void start();
signals:
    void done();
private:
    SourceServer *mSourceServer;
    KolabServer *mKolabServer;
};

#endif // COORDINATIONJOB_H
