/*
 * Copyright (C) 2012  Christian Mollekopf <mollekopf@kolabsys.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef KOLABSERVER_H
#define KOLABSERVER_H
#include <QObject>
#include <kolabobject.h>
#include <kimap/loginjob.h>

namespace KIMAP {
class Session;
}

class KolabAccount;
class KolabServer: public QObject
{
    Q_OBJECT
public:
    explicit KolabServer(QObject* parent = 0);
    
    void setHost(const QString &host, qint16 port);
    void setAdminCredentials(const QString &username, const QString &pw);
    void setDryRun(bool);
    
    KolabAccount *getAccount(const QString &user);
    void setVersion(Kolab::Version);
private:
    void logout();
    KIMAP::Session *mSession;
    QString mHost;
    int mPort;
    QString mUsername;
    QString mPw;
    KIMAP::LoginJob::EncryptionMode mEncryptionMode;
    KIMAP::LoginJob::AuthenticationMode mAuthenticationMode;
    bool mDryRun;
    Kolab::Version mVersion;
};

#endif // KOLABSERVER_H
