/*
 * Copyright (C) 2012  Christian Mollekopf <mollekopf@kolabsys.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "migratefolderjob.h"
#include "sourceaccount.h"
#include "kolabaccount.h"
#include <kolab/errorhandler.h>

MigrateFolderJob::MigrateFolderJob(const QString &folder, SourceAccount* sourceAccount, KolabAccount *kolabAccount, QObject* parent)
:   mSourceAccount(sourceAccount),
    mKolabAccount(kolabAccount),
    mFolder(folder)
{

}

void MigrateFolderJob::start()
{
    const QPair<Kolab::FolderType, QString> &targetFolder = mSourceAccount->translateFolder(mFolder);
    mKolabAccount->createFolder(targetFolder.second, targetFolder.first);
    QList<Object> messages = mSourceAccount->getObjects(mFolder);
    foreach (const Object &obj, messages) {
        mKolabAccount->appendObject(obj, targetFolder.second);
    }
    emitResult();
}