/*
 * Copyright (C) 2012  Christian Mollekopf <mollekopf@kolabsys.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef MIGRATEUSERJOB_H
#define MIGRATEUSERJOB_H

#include <kjob.h>

class SourceAccount;
class KolabAccount;
class MigrateUserJob: public KJob
{
    Q_OBJECT
public:
    explicit MigrateUserJob(SourceAccount *sourceAccount, KolabAccount *kolabAccount, QObject* parent = 0);
    virtual void start();
private slots:
    void migrateFolders(const QStringList &);
private:
    SourceAccount *mSourceAccount;
    KolabAccount *mKolabAccount;
};

#endif // MIGRATEUSERJOB_H
