/*
 * Copyright (C) 2012  Christian Mollekopf <mollekopf@kolabsys.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef UPGRADEUTILITIES_H
#define UPGRADEUTILITIES_H
#include <QString>
#include <kolabobject.h>
#include <kmime/kmime_message.h>

namespace Kolab {
    namespace Upgrade {
/**
 * Takes a v2 xml document and returns a v3 version
 */
// QString upgradeEventXML(const QByteArray &xmlData);

/**
 * Takes a v2 mime message and returns a v3 version
 */
KMime::Message::Ptr upgradeMessage(KMime::Message::Ptr msg, Kolab::ObjectType overrideObjectType = Kolab::InvalidObject);
QString upgradeMime(const QByteArray &, Kolab::ObjectType overrideObjectType = Kolab::InvalidObject);



    }
}

#endif